<?php

namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Teknisa\PLA\Modules\Parametros\Services\Ger08400CadastramentosAutomaticoService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error; 
use Teknisa\Libs\Util\XLS\Exception;
use Teknisa\GER\Controllers\TeknisaCrud;

class Ger08400CadastramentosAutomaticoController extends TeknisaCrud {
    
    protected $crudService;
    protected $parameterBag;
    protected $service;
    
    public function __construct($crudService, $parameterBag, Ger08400CadastramentosAutomaticoService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function importXls(DTO\Request $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $table = $this->service->readXls($row); 
            $rows = $this->service->formatXls($table, $row['NMTABELA']);
            $response->addDataSet(new DataSet('import', $rows));
        }
        catch(Exception $e){
            $errors = $e->getErrors();
            $response->addDataSet(new DataSet('errors', $errors));
            $response->setError(new Error($e->getMessage(), 500));
        }
        catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}