<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

class Pla15100FormasDePreparo extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "formapreparo";
    protected $entityManager;

    public function __construct($crudService, $parameterBag, $entityManager) {
    	$this->crudService = $crudService;
    	$this->parameterBag = $parameterBag;
    	$this->entityManager = $entityManager;
    }

	public function save(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		if ($row['__is_new'])
			// $row['NRFORMAPREPARO'] = $this->retornaProximoCodigo();
		parent::save($request, $response);
	}

	private function retornaProximoCodigo() {
		$sql = "SELECT NVL(MAX(NRFORMAPREPARO), 0) + 1 AS NRFORMAPREPARO FROM FORMAPREPARO WHERE NRORG = :NRORG";
		$params = array("NRORG" => $this->crudService->getEnvironment()->getNrOrg());
		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result[0]['NRFORMAPREPARO'];
	}
}